<?php

namespace common\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\models\SeoDynamic;

/**
 * SeoDynamicSearch represents the model behind the search form about `common\models\SeoDynamic`.
 */
class SeoDynamicSearch extends SeoDynamic
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['seo_dynamic_id', 'seo_category_id', 'status'], 'integer'],
            [['name', 'action', 'fields', 'title', 'h1', 'description', 'seo_text'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($seo_category_id, $params)
    {
        $query = SeoDynamic::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'seo_dynamic_id' => $this->seo_dynamic_id,
            'seo_category_id' => $seo_category_id,
            'status' => $this->status,
        ]);

        $query->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'action', $this->action])
            ->andFilterWhere(['like', 'fields', $this->fields])
            ->andFilterWhere(['like', 'title', $this->title])
            ->andFilterWhere(['like', 'h1', $this->h1])
            ->andFilterWhere(['like', 'description', $this->description])
            ->andFilterWhere(['like', 'seo_text', $this->seo_text]);

        return $dataProvider;
    }
}
